$!-----------------------------------------------------------------'f$verify(0)
$! INSTALL.COM
$!
$! WASD VMS Hypertext Services, Copyright (C) 1996-2004 Mark G.Daniel.
$! This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
$! This is free software, and you are welcome to redistribute it
$! under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.
$!
$! Install the WASD Hypertext Services Package.
$!
$! @INSTALL INSTALL  !overrides the 'already-installed' check and exit!
$!
$ INSTALL_VERSION = "v8.4.4"
$!
$! 07-DEC-2002  MGD  v8.1, major revision
$! 07-JUN-2002  MGD  v8.0, new version
$! 03-NOV-2001  MGD  v7.2.1, PERSONA_MACRO build
$! 12-MAY-2001  MGD  v7.2, adjust HTTP$SERVER account quotas upwards
$! 01-SEP-2000  MGD  v7.1, adjust disk quota upwards
$! 20-MAY-2000  MGD  v7.0, new version
$! 30-NOV-1999  MGD  v6.1, remove NETLIB support,
$!                         compile+link or link-only
$!                         bugfix; HT_ROOT derived from concealed device
$! 18-MAY-1999  MGD  v6.0
$! 14-NOV-1998  MGD  v5.3, new server startup procedure
$! 03-SEP-1998  MGD  v5.2
$! 28-JUL-1998  MGD  allow for enabled disk quotas
$! 27-JUN-1998  MGD  initial, v5.1 (and some would say long overdue!)
$!-----------------------------------------------------------------------------
$!
$ if f$trnlnm("INSTALL$DBUG") .nes. "" then set verify
$!
$ ss$_abort = 44
$ ss$_bugcheck = 676
$ delete = "delete"
$ copy = "copy"
$ say = "write sys$command"
$ vms_version = f$integer(f$extract(1,1,f$getsyi("version"))) * 10 +-
                f$integer(f$extract(3,1,f$getsyi("version")))
$ if vms_version .ge. 72 then set process /parse=traditional
$ archName = f$edit(f$getsyi("ARCH_NAME"),"UPCASE")
$ if archName .eqs. "ALPHA" then archName = "AXP"
$ set control=Y
$ on controly then exit ss$_abort
$!
$ if f$trnlnm("HT_ROOT","LNM$SYSTEM") .nes. "" .and. P1 .nes. "INSTALL"
$ then
$    type SYS$INPUT

                  *****************************************
                  *    "HT_ROOT" LOGICAL NAME DETECTED.   *
                  *  THIS DOES NOT LOOK LIKE AN INSTALL!  *
                  *****************************************

$    exit
$ endif
$!
$ if f$trnlnm("HT_ROOT","LNM$JOB") .eqs. ""
$ then
$!   (subprocess to do the actual work, define local logicals)
$    procCom = f$environment("PROCEDURE")
$    procDev = f$parse(procCom,,,"DEVICE","NO_CONCEAL")
$    procDir = f$parse(procCom,,,"DIRECTORY","NO_CONCEAL")
$    htRoot = procDev+f$extract(0,f$locate("HT_ROOT",procDir)+7,procDir)+".]"
$    define /job /nolog /translation=concealed HT_ROOT 'htRoot'
$    htExe = "HT_ROOT:[''archName']"
$    define /job /nolog HT_EXE 'htExe'
$!   (spawn a subprocess to do the actual install ensures job logical deletion)
$    set noon
$    spawn /wait @'procCom' "''p1'"
$    set on
$    deassign /job HT_ROOT
$    deassign /job HT_EXE
$    exit
$ endif
$!
$ currentDefault = f$environment("DEFAULT")
$!
$    type sys$input

     WASD VMS Hypertext Services, Copyright (C) 1996-2004 Mark G.Daniel.
 This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
     This is free software, and you are welcome to redistribute it under
        the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.

               ************************************************
$ say "               *  INSTALL WASD VMS HYPERTEXT SERVICES ''INSTALL_VERSION'  *"
$ type sys$input
               ************************************************

All sections may be individually declined before making any modifications.
In this sense the install may be undertaken step-by-step or sections repeated.
The first section is COMPILING/LINKING, after which you will be able to quit.
In a mixed architecture cluster (including both Alpha and VAX systems) the
compile/link section must be performed on both!

$ read sys$command response /prompt="Press RETURN to continue: "
$ say ""
$!
$ if f$search("HT_ROOT:[000000]*.*") .eqs. ""
$ then
$    type sys$input
          *********************************************************
          *  APPEARS TO BE A PROBLEM WITH THE "HT_ROOT" LOGICAL!  *
          *********************************************************

$    exit ss$_abort
$ endif
$!                         ***********************
$!                         *  BUILD EXECUTABLES  *
$!                         ***********************
$!
$ @HT_ROOT:[INSTALL]BUILD.COM
$!
$ type sys$input
                          ************************
                          *  SERVER QUICK-CHECK  *
                          ************************

This executes the package demonstration procedure, allowing the basic package
to be evaluated or checked.  You may run this at any time to again check the
package for basic functionality using @HT_ROOT:[INSTALL]DEMO.COM

$ response = ""
$ read sys$command response /prompt="Execute the demonstration procedure? [NO]: "
$ say ""
$ if response
$ then
$    @HT_ROOT:[INSTALL]DEMO.COM
$ endif
$!
$ type sys$input
                        ****************************
                        *  CONTINUE INSTALLATION?  *
                        ****************************

$ response = ""
$ read sys$command response /prompt="Continue the installation? [NO]: "
$ say ""
$ if .not. response then exit
$!
$!(create accounts)
$ @HT_ROOT:[INSTALL]ACCOUNTS INSTALL
$ if .not. $status then exit $status
$!
$!(ensure HT_ROOT.DIR has required file protections)
$ htRootDir = f$trnlnm("ht_root",,"no_conceal") - ".]" + ".-]HT_ROOT.DIR"
$ set file /owner=SYSTEM /protection=(s:rwed,o:rwed,g:re,w:re) 'htRootDir'
$!
$!(secure the package tree)
$ @HT_ROOT:[INSTALL]SECURE INSTALL
$ if .not. $status then exit $status
$!
$ type sys$input
                          *************************
                          *  HTTPD SUPPORT FILES  *
                          *************************

Copies files from HT_ROOT:[EXAMPLE]

  STARTUP.COM           to    HT_ROOT:[STARTUP]
  STARTUP_DECNET.COM    to    HT_ROOT:[STARTUP]
  STARTUP_LOCAL.COM     to    HT_ROOT:[STARTUP]
  STARTUP_SERVER.COM    to    HT_ROOT:[STARTUP]

  HTTPD$AUTH.CONF       to    HT_ROOT:[LOCAL]
  HTTPD$CONFIG.CONF     to    HT_ROOT:[LOCAL]
  HTTPD$MAP.CONF        to    HT_ROOT:[LOCAL]
  HTTPD$MSG.CONF        to    HT_ROOT:[LOCAL]

$ response = ""
$ read sys$command response /prompt="Copy the files? [NO]: "
$ say ""
$ if response
$ then
$    copy = "copy/log"
$    copy ht_root:[example]startup.com        ht_root:[startup]
$    copy ht_root:[example]startup_decnet.com ht_root:[startup]
$    copy ht_root:[example]startup_local.com  ht_root:[startup]
$    copy ht_root:[example]startup_server.com ht_root:[startup]
$    copy ht_root:[example]httpd$auth.conf    ht_root:[local]
$    copy ht_root:[example]httpd$config.conf  ht_root:[local]
$    copy ht_root:[example]httpd$map.conf     ht_root:[local]
$    copy ht_root:[example]httpd$msg.conf     ht_root:[local]
$    say ""
$ endif
$!
$ type sys$input
                        *****************************
                        *  INSTALL PACKAGE SCRIPTS  *
                        *****************************

The procedure HT_ROOT:[INSTALL]SCRIPTS.COM installs package scripts.
It prompts for selected groups of scripts to be installed or removed.  More
information is available when using the procedure.  Scripts available with this
release of the package will not be available for use by the server until this
procedure is performed.

You can execute the procedure now or do it later manually.

$ response = ""
$ read sys$command response /prompt="Execute the procedure now? [NO]: "
$ say ""
$ if response
$ then
$    @HT_ROOT:[INSTALL]SCRIPTS.COM
$!   'f$verify(0)
$    set default 'currentDefault'
$ endif
$!
$ type sys$input
                       *******************************
                       *  INSTALL   C O M P L E T E  *
                       *******************************

$!-----------------------------------------------------------------------------
